lisp.c

LISP Interpreter Run

[[[
 Show that
    H(X set-union Y) <= H(X) + H(Y) + 1799
 and that
    H(X set-intersection Y) <= H(X) + H(Y) + 1799.
 Here X and Y are INFINITE sets.
]]]

[IMPORTANT: This test case never halts, so] [<=====!!!]
[must run this with a depth limit on try/?]

[Combine two bit strings by interleaving them]
& (Cxy) /.xy /.yx *+x*+yC-x-y

C:          (&(xy)(/(.x)y(/(.y)x(*(+x)(*(+y)(C(-x)(-y)))))))


& (Dl) /.l"? ('&(xy)x D-l ,+l)   [display list in reverse]

D:          (&(l)(/(.l)?(('(&(xy)x))(D(-l))(,(+l)))))


D-
[[[++]]] ? ++?0'%#'"({768}) '!%

^#'"( [begin literally]

[Package of set functions from sets0.l]
: (Mes) /.s0 /=e+s1 Me-s
: (Ds) /.s() /M+s-s D-s *+sD-s
: (Uxy) /.xy /M+xy U-xy *+xU-xy
: (Ixy) /.x() /M+xy *+xI-xy I-xy
: (Sxy) /.x() /M+xy S-xy *+xS-xy
: (Os) /.s() *,+sO-s
[Main Loop:
 o is set of elements output so far.
 For first set,
 t is depth limit (time), b is bits read so far.
 For second set,
 u is depth limit (time), c is bits read so far.
]
: (Lotbuc)
 : v     ?t'!%b      [Run 1st computation again.]
 : w     ?u'!%c      [Run 2nd computation again.]
 : x     I-v-w       [Form INTERSECTION of sets so far]
 : y     OSxo        [Output all new elements]
 [This is an infinite loop. But to make debugging easier,
  halt if EITHER computation has halted.]
 / /=0.+v1 /=0.+w1 0 "?
 [Bump everything before branching to head of loop]
 L x                 [Value of y is discarded, x is new o]
   /="?+v *1t    t   [Increment time for 1st computation]
   /="!+v ^b*@() b   [Increment tape for 1st computation]
   /="?+w *1u    u   [Increment time for 2nd computation]
   /="!+w ^c*@() c   [Increment tape for 2nd computation]

L()()()()()          [Initially all 5 induction variables
                      are empty.]
)                    [end literally]

C                    [Combine their bits in order needed]
                     [Wrong order if programs use @ or %]
                     [Program to enumerate 1st INFINITE set]
#'"( :(Lk)L,*1*1k L() )
                     [Program to enumerate 2nd INFINITE set]
#'"( :(Lk)L,*1*1*1k L() )

expression  (D(-(?(+(+(?0('(%))(#('({768}))))))('(!(%)))(^(#('
            (:(Mes)/.s0/=e+s1Me-s:(Ds)/.s()/M+s-sD-s*+sD-s:(Ux
            y)/.xy/M+xyU-xy*+xU-xy:(Ixy)/.x()/M+xy*+xI-xyI-xy:
            (Sxy)/.x()/M+xyS-xy*+xS-xy:(Os)/.s()*,+sO-s:(Lotbu
            c):v?t'!%b:w?u'!%c:xI-v-w:yOSxo//=0.+v1/=0.+w10"?L
            x/="?+v*1tt/="!+v^b*@()b/="?+w*1uu/="!+w^c*@()cL()
            ()()()())))(C(#('(:(Lk)L,*1*1kL())))(#('(:(Lk)L,*1
            *1*1kL()))))))))
display     (111111)
display     (111111111111)
display     (111111111111111111)
display     (111111111111111111111111)
display     (111111111111111111111111111111)
display     (111111111111111111111111111111111111)
display     (111111111111111111111111111111111111111111)
display     (111111111111111111111111111111111111111111111111)
display     (1111111111111111111111111111111111111111111111111
            11111)
value       ?

End of LISP Run

Elapsed time is 1 seconds.
